/*****************************************************************
 *
 *  Cifstream.h                      XMM Science Analysis Subsystem
 *
 *  An ifstream using a CommentBuf
 *
 *  (c) 1998 ESA  -  Written by Jon Brumfitt, Aurora
 *                -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: Cifstream.h,v 1.1 2000/04/14 09:39:50 jbakker Exp $
 *
 *****************************************************************/

#ifndef CIFSTREAM_H
#define CIFSTREAM_H

#include <iostream.h>          // C++ headers
#include <fstream.h>

#include "CommentBuf.h"
#include "Cistream.h"


/*****************************************************************
 *  Class Cifstream
 *
 *  An ifstream using a CommentBuf
 *
 *  A Cifstream is used like a normal ifstream, except that it strips
 *  comments and provides member functions for getting the current
 *  line and its line number. For example:
 *
 *      Cifstream is("data");
 *
 *****************************************************************/

class Cifstream : public Cistream
{
public:

    // Create a Cifstream from an existing file descriptor
    Cifstream(int fd)
      : Cistream(_is.rdbuf()),_is(fd) { setstate(_is.rdstate()); }

    // Create a Cifstream by opening a file
    Cifstream(const char* name, int mode=ios::in, int prot=0664)
        : Cistream(_is.rdbuf()),_is(name,mode,prot) { setstate(_is.rdstate()); }

protected:
    
    // Member data
    ifstream _is;
};

#endif
