/*****************************************************************
 *
 *  Cistrstream.h                    XMM Science Analysis Subsystem
 *
 *  An istrstream using a CommentBuf
 *
 *  (c) 1998 ESA  -  Written by Jon Brumfitt, Aurora
 *                -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: Cistrstream.h,v 1.1 2000/04/14 09:39:50 jbakker Exp $
 *
 *****************************************************************/

#ifndef CISTRSTREAM_H
#define CISTRSTREAM_H

#include <iostream.h>          // C++ headers
#include <strstream.h>
#include <string>

#include "CommentBuf.h"
#include "Cistream.h"


/*****************************************************************
 *  Class Cistrstream
 *
 *  An istrstream using a CommentBuf
 *
 *  A Cistrstream is used like a normal istrstream, except that it 
 *  strips comments and provides member functions for getting the 
 *  current line and its line number. For example:
 * 
 *       Cistrstream is("1 2#comment\n3 4");
 *
 *****************************************************************/

class Cistrstream : public Cistream
{
public:
    
    // Construct a Cistrstream from a text string
    Cistrstream(const char* str, int n=0)
      :  Cistream(_is.rdbuf()),_is(str,n) { setstate(_is.rdstate()); }

protected:

    // Member data
    istrstream  _is;
};

#endif
