/*****************************************************************************
 *
 *  LayoutPrinter.h                             XMM Science Analysis Subsystem
 *
 *  Plug-in printer for testing GUI layout classes
 *
 *  (c) 1998-2000  ESA  -  Written by Jon Brumfitt, Aurora
 *                      -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: LayoutPrinter.h,v 1.1 2000/04/14 09:39:51 jbakker Exp $
 *
 *****************************************************************************/

#ifndef LAYOUTPRINTER_H
#define LAYOUTPRINTER_H

#include "LayoutBuilder.h"

#include <iostream.h>
#include <iomanip.h>


//================================================================
//  Class LayoutPrinter
//================================================================

/*** Output manipulator to indent line ***/

inline ostream& indentManip(ostream& os, int n)
{
    for(int i=0; i<n; i++)
        os << ' ';
    return os;
}

inline omanip<int> indent(int n)
{ 
    return omanip<int>(&indentManip,n); 
}

class LayoutPrinter : public LayoutBuilder
{
public:
    LayoutPrinter(ostream* os, int indent=0) : _os(os), _indent(indent) {}
    void buildSimple(Layout*);
    void buildFrame(Layout*);
    void buildCards(Layout*);
    void buildRow(Layout*);
    void buildColumn(Layout*);
    void buildEnable(Layout*);
    void buildChoice(Layout*);

private:
    ostream* _os;
    int      _indent;
};

#endif
